<?php
/*
* ------------------------------------------------------------------------------------------------------------
*	Ovo je HTML/PHP/JAVASCRIPT chat za web sajtove
*	Ovaj kod je pisao Mihajlo Kucina
	
*	
*	Za sva pitanja kontaktirajte me na mihajlo224@gmail.com
*	
*	Copyright 2009 Mihajlo Kucina @ Croatia
* ------------------------------------------------------------------------------------------------------------
*/
if ($_GET['action'] == 'get_messages') {header("Content-Type: text/xml; charset=utf-8");}
session_start();

if (!empty($_SESSION['last_action_time']) && microtime_float() - $_SESSION['last_action_time'] > 10.0) {
	$_SESSION = array();
}

define("PASSWORD", "0000");

if ($_GET['action'] && $_SESSION['auth'] == true) {
   switch ($_GET['action']) {
		case 'logout':
			remove_user($_SESSION['name']);
			session_destroy();
			header("Location: " . $_SERVER['PHP_SELF']);
			break;
		case 'get_messages':
			changeRoom();
			$xml = false;
			$xml = '<?xml version="1.0" ?><root>';
			$xml.= get_messages($_SESSION['last_action_time']);
			$xml.= get_userlist();
			$xml.= '</root>';
			echo $xml;
			die;
			break;
   }
}
  
if ($_POST['msg'] && $_SESSION['auth'] == true) {
   write_message(microtime_float(), $_SESSION['room'], $_SESSION['name'], $_POST['msg']);
   die;
}
  
if ($_POST['name'] && $_POST['password'] && $_SESSION['auth'] == false) {
   $_SESSION['name'] = $_POST['name'];
   if ($_POST['password'] == PASSWORD) {
		$_SESSION['auth'] = true;
		$_SESSION['room'] = '1';
      $_SESSION['last_action_time'] = microtime_float();
      add_user($_SESSION['last_action_time'], $_SESSION['name']);
   }
	else {
		$msg = "<h3 class='error'>Pogresna lozinka!!!</h3>";
   }
}

function changeRoom() {
	if (!empty($_GET['room']) && $_GET['room'] != $_SESSION['room']) {
		$timestamp = microtime_float()-1;
		write_message(microtime_float(), $_SESSION['room'], "Chatbot", $_SESSION['name']." ist jetzt in Raum ".$_GET['room']);
		write_message($timestamp, $_GET['room'], "Chatbot", $_SESSION['name']." Je pristupio");
		$_SESSION['room'] = $_GET['room'];
	}
}

function get_messages($timestamp) {
   if (!file_exists(CHAT_FILE)) { die; }
   $data = file(CHAT_FILE);
   foreach ($data as $line) {
		$chunks = explode("\t", $line);
      if ($chunks[0] > $timestamp && $chunks[1] == $_SESSION['room']) {
			$new_msg[0][1] = $chunks[1];
			$new_msg[0][2] = $chunks[2];
			$new_msg[0][3] = $chunks[3];
			$new_msg[0][4] = $chunks[4];
		}
   }
	if (!is_array($new_msg)) { $new_msg = array(); }
	update_last_action(microtime_float(), $_SESSION['name']);
   foreach ($new_msg as $msg) {
		$xml .= '<message>';
		$xml .= '<room>' . $msg[1] . '</room>'; //room
		$xml .= '<time>' . $msg[2] . '</time>'; //time
		$xml .= '<user>' . $msg[3] . '</user>'; //user
		$xml .= '<mess>' . htmlspecialchars($msg[4]) . '</mess>'; //mess
		$xml .= '</message>';
   }
   return $xml;
}

if ($_REQUEST['smilie']) {make_smilie($_REQUEST['smilie']);}
function make_smilie($smilie) {
	header("Content-type: image/png");
	$text = $smilie;
	$Grafik = imagecreate(20, 20);
	$Hintergrundfarbe = imagecolorallocate($Grafik, 223, 239, 255);
	$Textfarbe = imagecolorallocate($Grafik, 225, 0, 0);
	$col = imagecolorallocate($Grafik, 0, 0, 0);
	imagefilledellipse($Grafik, 10, 10, 19, 19, $col);
	$col = imagecolorallocate($Grafik, 255, 204, 0);
	imagefilledellipse($Grafik, 10, 10, 17, 17, $col);
	imagestring($Grafik, 2, 1, 3,  $text, $Textfarbe);
	$Grafik = imagerotate($Grafik, 270, 0);
	imagepng($Grafik);
	imagedestroy($Grafik);
	$_REQUEST['smilie'] = "";
}

function update_last_action($timestamp, $name) {
   $users = get_user_array();
   if (!$handle = fopen(USER_FILE, "w+")) { die("Konnte User-Datei nicht anlegen!"); }
   if (!chmod(USER_FILE, 0700)) { die("Konnte User-Datei nicht schützen!"); }
   foreach($users as $user) {
      $chunks = explode("\t", $user);
      if (trim($chunks[1]) == trim($name)) {
			fwrite($handle, $timestamp . "\t" . $name . "\t" . $_SESSION['room'] . "\n");
			$_SESSION['last_action_time'] = $timestamp;
      } else {
			if (microtime_float() - $chunks[0] > 15.0) {
				remove_user($chunks[1]);
			} else {
				fwrite($handle, $user);
			}        
      }
   }
}
  
function write_message($timestamp, $room, $name, $msg) {
   if (!$handle = fopen(CHAT_FILE, "a")) { die("Konnte Chat-Datei nicht anlegen!"); }
   if (!chmod(CHAT_FILE, 0700)) { die("Konnte Chat-Datei nicht schützen!"); }
   fwrite($handle, $timestamp . "\t" . $room . "\t" . date("H:i:s", time()) . "\t" . $name . "\t" . htmlspecialchars(nl2br(wordwrap ($msg,42,' ',1))) . "\n");
   fclose($handle);
}
  
function get_userlist() {
   $data = get_user_array();
   $list = "";
   foreach($data as $entry) {
		$chunks = explode("\t", $entry);
		if (trim($chunks[2]) == $_SESSION['room']) {
			$xml .= '<userlist>';
			$xml .= '<username>' . $chunks[1] . '</username>'; //username
			$xml .= '<room>' . $chunks[2] . '</room>'; //room
			$xml .= '</userlist>';
		}
   }
	return $xml;
}
 
function get_user_array() {
   if (!file_exists(USER_FILE)) { return array(); }
   $data = file(USER_FILE);
   if (!is_array($data)) { $data = array(); }
   return $data;
}
  
function add_user($timestamp, $user) {
   $users = get_user_array();
   if (!$handle = fopen(USER_FILE, "w+")) { die("Konnte User-Datei nicht anlegen!"); }
   if (!chmod(USER_FILE, 0700)) { die("Konnte User-Datei nicht schützen!"); }
   foreach ($users as $name) {
      $chunks = explode("\t", $name);
		if (trim($chunks[1]) == trim($user)) {
			$msg = "<h3 class='error'>Benutzer ist bereits eingeloggt!</h3>";
			$_SESSION['auth'] = false;
		} else {
			if (microtime_float() - $chunks[0] > 15.0) {
				remove_user($chunks[1]);
			} else {
				fwrite($handle, $name );
			}
		}
	}
	if ($_SESSION['auth'] == true) {
		fwrite($handle, $timestamp . "\t" . $user . "\t" . $_SESSION['room']. "\n");
		write_message($timestamp, $_SESSION['room'], "Chatbot", "$user je pristupio chat-u");
	}
	fclose($handle);
}
  
function remove_user($user) {
   $users = get_user_array();    
   if (!$handle = fopen(USER_FILE, "w+")) { die("Konnte User-Datei nicht aktualisieren!"); }
   foreach ($users as $name) {
		$chunks = explode("\t", $name);
      if (trim($chunks[1]) != trim($user)) {
			fwrite($handle, $name);
		}
   }
   write_message(microtime_float(), $_SESSION['room'], "Chatbot", trim($user)." hat den Chat verlassen");
   fclose($handle);
   $users = get_user_array();
   if (count($users) == 0) {
		unlink(CHAT_FILE);
   }
}
  
function microtime_float() {
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}
  
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="de" xml:lang="de">
 <head>
   <title>Techno Chat</title>
   <meta http-equiv="content-type" content="text/html;charset=UTF-8" />

	
<?php
  if ($_SESSION['auth'] != false) {
?>	
<script type="text/javascript">
<!--
var sendReq = getXmlHttpRequestObject();
var receiveReq = getXmlHttpRequestObject();
var room = '1';

function blockSubmit() {
	sendMessage();
	return false;
}

function startChat() {
	document.getElementById('msginput').focus();
	mTimer = setTimeout('getMessages();',300);
}		

function getXmlHttpRequestObject() {
	if (window.XMLHttpRequest) {
		return new XMLHttpRequest();
	} else if(window.ActiveXObject) {
		return new ActiveXObject("Microsoft.XMLHTTP");
	} else {
		document.getElementById('messages').innerHTML = 'Status: Cound not create XmlHttpRequest Object.  Consider upgrading your browser.';
	}
}
function getMessages(r) {
	if (receiveReq.readyState == 4 || receiveReq.readyState == 0) {
		if (!r) {var r = '';} else { var r = '&room='+room; }
		receiveReq.open("GET", '<?php echo $_SERVER['PHP_SELF']; ?>' + '?action=get_messages'+r, true);
		receiveReq.onreadystatechange = handleReceiveMessages; 
		receiveReq.send(null);
	}
}
function handleReceiveMessages() {
	if (receiveReq.readyState == 4) {
		clearInterval(mTimer);
		var time_div = document.getElementById('time');
		var d = new Date();
		var s = d.getHours(); var m = d.getMinutes();
		if (s <= 9) {var st = '0' + s;} else {var st = ' '+s;}
		if (m <= 9) {var mi = '0' + m;}else {var mi = ' '+m;}
		var time = st + ':' + mi;
		time_div.innerHTML = '<b>' + time + '</b>';
		var chat_div = document.getElementById('messages');
		var user_div = document.getElementById('userlist');
		var xmldoc = receiveReq.responseXML;
		var message_nodes = xmldoc.getElementsByTagName("message"); 
		var n_messages = message_nodes.length
		for (i = 0; i < n_messages; i++) {
			var time_node = message_nodes[i].getElementsByTagName("time");
			var user_node = message_nodes[i].getElementsByTagName("user");
			var text_node = message_nodes[i].getElementsByTagName("mess");
			var rot = ''; var blau = '';
			if (user_node[0].firstChild.nodeValue == 'Chatbot') {
				rot = '<i style="color: #ff0000;">';
				var dp = '';
			} else {
				var dp = ':';
			}
			chat_div.innerHTML += '<font class="chat_time">(' + time_node[0].firstChild.nodeValue + ') </fon>';
			if (user_node[0].firstChild.nodeValue != 'Chatbot') {
				chat_div.innerHTML += '<b>' + user_node[0].firstChild.nodeValue + dp + ' </b>';
			}
			var utext = make_smilie(text_node[0].firstChild.nodeValue);
			chat_div.innerHTML += rot + utext + '<br>';
			chat_div.scrollTop = chat_div.scrollHeight;
		}
		
		var user_nodes = xmldoc.getElementsByTagName("userlist"); 
		var tmp = '';
		var n_user = user_nodes.length

		for (i = 0; i < n_user; i++) {
			var username = user_nodes[i].getElementsByTagName("username");
			tmp += username[0].firstChild.nodeValue+'<br>';
		}
		if (user_div.innerHTML != tmp) {user_div.innerHTML = tmp;}
		var anz = document.getElementById('user');
		if (anz.innerHTML != '<b>User:</b> ' + i) {anz.innerHTML = '<b>User:</b> ' + i;}
		
		mTimer = setTimeout('getMessages();',2000); //
	}
}

function make_smilie(text) {
	text = text.replace(':-)',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-)\">");
	text = text.replace(';-)',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=;-)\">");
	text = text.replace(':-D',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-D\">");
	text = text.replace(':)',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-)\">");
	text = text.replace(':D',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-D\">");
	text = text.replace(';)',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=;-)\">");
	text = text.replace(':-O',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-O\">");
	text = text.replace(':O',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-O\">");
	text = text.replace(':-P',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-P\">");
	text = text.replace(':P',"<img src=\"<? echo $_SERVER['PHP_SELF']; ?>?smilie=:-P\">");
	return text;
}

function sendMessage(m) {
	if(document.getElementById('msginput').value == '') {
		return;
	}
	if (sendReq.readyState == 4 || sendReq.readyState == 0) {
		sendReq.open("POST", '<?php echo $_SERVER['PHP_SELF']; ?>', true);
		sendReq.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		sendReq.onreadystatechange = handleSendMessage;
		var param = 'msg=' + document.getElementById('msginput').value;
		sendReq.send(param);
		document.getElementById('msginput').value = '';
		
	}
}
function handleSendMessage() {
	clearInterval(mTimer);
	mTimer = setTimeout('getMessages();',150);
}

function changeTab(obj, r) {
	if (r != room) {
		clearInterval(mTimer);
		var allobj = document.getElementsByTagName('li');
	
		for (var i = 0; i < allobj.length; i++) {
			var thisElem = allobj[i];
			if (thisElem.className  == 'tabsel') {
				thisElem.className  = 'tab';
			}
		}
		obj.className = 'tabsel';
		room = r;
		document.getElementById('messages').innerHTML = '<center><i style="color: #003366;">Vi ste sada u sobi ' + room + '</center><br>';
		getMessages(r);
	}
	document.getElementById('msginput').focus();
}
//-->
</script>
<?php
}
?>
<style type="text/css">
<!--
@charset "utf-8";
* {
	margin: 0;
	padding: 0;
	font-family: Verdana, Arial, Helvetica, sans-serif;
	font-size: 12px;
}
body, .error, .success, p.link { 
	text-align: center;
	background-color: #223344;
	padding-top: 25px;
	color: #efefef;
}
p {
	margin: 0.2em 0;
}
.error {
	color: red;
}
.success {
	color: green;
}
a {
	color: #fff;
}
.clearer {
	clear: both;
}
label.small {
	font-size: 0.8em;
	color: #999;
}
div#login, div#chat {
	background-color: #4f5f6f;
	border: 1px solid #999;
	margin: 0 auto;
	padding: 10px 20px 20px 20px;
	width: 300px;
	text-align: center;
}
div#chat {
	width: 700px;
	text-align: left;
}
div#messages, div#userlist { 
	width: 533px;
	height: 300px;
	color: #000000;
	background-color: #dfefff;
	border: 1px solid #eee; 
	float: left;
	text-align: left;
	padding: 0px 5px 0px 5px;
	overflow: auto;
}
div#userlist {
	width: 133px;
	margin: 0 0 10px 10px;
} 
input#msginput { 
	background-color: #dfefff;
	border: 1px solid #eee; 
	width: 537px;
	padding: 3px;
	margin-right: 10px;
}
/*
input#msginput:focus {
	border: 1px solid #000; 
}
*/
#time {
	text-align: right;
	padding-bottom: 10px;
}
img {
	position: relative;
	top: 6px;
	width: 20px;
	height: 20px;
	margin-top: -4px;
	padding-bottom: 2px;
}
.chat_time {
	font-style: italic;
	font-size: 8px;
}
#user {
	float: left;
}

#tabsel {
	width: 545px;
}
ul#tabnav {
	text-align: left;
	margin: 1em 0 0 0;
	font: bold 11px verdana, arial, sans-serif;
	border-bottom: 1px solid #666;
	list-style-type: none;
	padding: 3px 10px 3px 10px;
}

ul#tabnav li {
display: inline;
}

#tabsel li.tabsel, #tab li.tab {
	border-bottom: 1px solid #fff;
	background-color: #dfefff;
}

#tabsel li.tabsel a, #tab li.tab a {
	background-color: #dfefff;
	color: #000;
	position: relative;
	top: 1px;
	padding-top: 4px;
}

ul#tabnav li a { /* settings for all tabsel links */
	padding: 3px 4px;
	border: 1px solid #666;
	background-color: #ccc;
	color: #666;
	margin-right: 0px;
	text-decoration: none;
	border-bottom: none;
}

ul#tabnav a:hover {
	background: #dfefff;
}

/* end css tabsels */
-->
</style>
  
</head> 
 <body <?php if ($_SESSION['auth'] != false) { echo "onload=\"startChat();\""; }?>>
  
  <?php
  if ($_SESSION['auth'] == false) {
  ?>  
<form name="login-form" action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
	<div id="login">
		<table>
			<tr><td>
				<label for="name">Name:</label>
			</td><td>
				<input type="text" maxlength="12" size="25" name="name" value="<?php echo $_SESSION['name']; ?>" />
			</td></tr>
			<tr><td>
				<label for="password">Lozinka:</label>
			</td><td>
				<input type="password" size="25" name="password" />
			</td></tr>
		</table>
	
		<input type="submit" value="Pristupi" /><br><br>Lozinka = 0000
   </div>
</form>
 
<?php
    } else {
?>
<h3>- Vi ste clan <?php echo $_SESSION['name']; ?> -</h3>

<div id="chat">
	<div id="On-line"><!-- --></div>
	<div id="time"><!-- --></div>
	<div id="tabsel">
		<ul id="tabnav">
			<li class="tabsel" onclick="changeTab(this, 1);"><a href="#">Soba 1</a></li>
			<li class="tab" onclick="changeTab(this, 2);"><a href="#">Soba 2</a></li>
			<li class="tab" onclick="changeTab(this, 3);"><a href="#">Soba 3</a></li>
			<li class="tab" onclick="changeTab(this, 4);"><a href="#">Soba 4</a></li>
		</ul>
	</div>
   <div id="messages"><!-- --></div>
   <div id="userlist"><!-- --></div>
	<p class="clearer"><!-- --></p>
	
	<form name="msg-form" onsubmit="return blockSubmit();">
		<input id="msginput" type="text" name="msginput" />
		<a href="<?php echo $_SERVER['PHP_SELF']; ?>?action=logout" title="Odjava">Odjava</a>
	</form>
</div>
<?php
}
echo $msg;
?>

  </body>
</html>
